#ifndef	_ASM_CPU_SH7786_H_
#define	_ASM_CPU_SH7786_H_

/*
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (c) 2007,2008 Nobuhiro Iwamatsu <iwamatsu@nigauri.org>
 * Copyright (c) 2008 Yusuke Goda <goda.yusuke@renesas.com>
 * Copyright (c) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 */

#define	CACHE_OC_NUM_WAYS	1
#define	CCR_CACHE_INIT		0x0000090b

/*	Exceptions	*/
#define	TRA	0xFF000020
#define	EXPEVT	0xFF000024
#define	INTEVT	0xFF000028

/* Cache Controller */
#define	CCR	0xFF00001C
#define	QACR0	0xFF000038
#define	QACR1	0xFF00003C
#define	RAMCR	0xFF000074

/* Watchdog Timer and Reset */
#define	WTCNT	WDTCNT
#define	WDTST	0xFFCC0000
#define	WDTCSR	0xFFCC0004
#define	WDTBST	0xFFCC0008
#define	WDTCNT	0xFFCC0010
#define	WDTBCNT	0xFFCC0018

/* Timer Unit */
#define	TSTR	TSTR0
#define	TSTR0	0xFFD80004
#define	TCOR0	0xFFD80008
#define	TCNT0	0xFFD8000C
#define	TCR0	0xFFD80010
#define	TCOR1	0xFFD80014
#define	TCNT1	0xFFD80018
#define	TCR1	0xFFD8001C
#define	TCOR2	0xFFD80020
#define	TCNT2	0xFFD80024
#define	TCR2	0xFFD80028
#define	TCPR2	0xFFD8002C
#define	TSTR1	0xFFDC0004
#define	TCOR3	0xFFDC0008
#define	TCNT3	0xFFDC000C
#define	TCR3	0xFFDC0010
#define	TCOR4	0xFFDC0014
#define	TCNT4	0xFFDC0018
#define	TCR4	0xFFDC001C
#define	TCOR5	0xFFDC0020
#define	TCNT5	0xFFDC0024
#define	TCR5	0xFFDC0028

/* Serial Communication	Interface with FIFO */
#define	SCIF0_BASE	0xFFEA0000
#define	SCIF1_BASE	0xFFEB0000
#define	SCIF3_BASE	0xFFEC0000
#define	SCIF4_BASE	0xFFED0000
#define	SCIF5_BASE	0xFFEE0000
#define	SCIF6_BASE	0xFFEF0000

/* LBSC */
#define MMSELR		0xFC400020
#define LBSC_BASE	0xFF800000
#define BCR		(LBSC_BASE + 0x1000)
#define CS0BCR		(LBSC_BASE + 0x2000)
#define CS1BCR		(LBSC_BASE + 0x2010)
#define CS2BCR		(LBSC_BASE + 0x2020)
#define CS3BCR		(LBSC_BASE + 0x2030)
#define CS4BCR		(LBSC_BASE + 0x2040)
#define CS5BCR		(LBSC_BASE + 0x2050)
#define CS6BCR		(LBSC_BASE + 0x2060)
#define CS0WCR		(LBSC_BASE + 0x2008)
#define CS1WCR		(LBSC_BASE + 0x2018)
#define CS2WCR		(LBSC_BASE + 0x2028)
#define CS3WCR		(LBSC_BASE + 0x2038)
#define CS4WCR		(LBSC_BASE + 0x2048)
#define CS5WCR		(LBSC_BASE + 0x2058)
#define CS6WCR		(LBSC_BASE + 0x2068)
#define CS5PCR		(LBSC_BASE + 0x2070)
#define CS6PCR		(LBSC_BASE + 0x2080)

/* GPIO */
#define GPIO_BASE	0xFFCC0000
#define PACR		(GPIO_BASE + 0x00)
#define PBCR		(GPIO_BASE + 0x02)
#define PCCR		(GPIO_BASE + 0x04)
#define PDCR		(GPIO_BASE + 0x06)
#define PECR		(GPIO_BASE + 0x08)
#define PFCR		(GPIO_BASE + 0x0a)
#define PGCR		(GPIO_BASE + 0x0c)
#define PHCR		(GPIO_BASE + 0x0e)
#define PJCR		(GPIO_BASE + 0x10)
#define PAPUPR		(GPIO_BASE + 0x40)
#define PBPUPR		(GPIO_BASE + 0x42)
#define PCPUPR		(GPIO_BASE + 0x44)
#define PDPUPR		(GPIO_BASE + 0x46)
#define PEPUPR		(GPIO_BASE + 0x48)
#define PFPUPR		(GPIO_BASE + 0x4A)
#define PGPUPR		(GPIO_BASE + 0x4C)
#define PHPUPR		(GPIO_BASE + 0x4E)
#define PJPUPR		(GPIO_BASE + 0x50)
#define PPUPR1		(GPIO_BASE + 0x60)
#define PPUPR2		(GPIO_BASE + 0x62)
#define P1MSELR		(GPIO_BASE + 0x80)
#define P2MSELR		(GPIO_BASE + 0x82)

#endif	/* _ASM_CPU_SH7786_H_ */
