/*
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (C) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/processor.h>

int checkboard(void)
{
	puts("BOARD: ALPHAPROJECT AP-SH4A-3A\n");
	return 0;
}

int board_init(void)
{
	writew(0xffff, PACR);
	writew(0xfff0, PBCR);
	writew(0x0000, PCCR);
	writew(0x0000, PDCR);
	writew(0x0fff, PECR);
	writew(0x5555, PFCR);
	writew(0x5555, PGCR);
	writew(0x5410, PHCR);
	writew(0x5551, PJCR);
	writew(0x5555, PKCR);
	writew(0x5551, PLCR);
	writew(0xfff5, PMCR);
	writew(0x5555, PNCR);
	writew(0x03c0, PPCR);
	writew(0x03ff, PQCR);
	writew(0x00ff, PRCR);

	writeb(0xff, PEPUPR);
	writeb(0xff, PHPUPR);
	writeb(0xff, PJPUPR);
	writeb(0xff, PKPUPR);
	writeb(0xff, PLPUPR);
	writeb(0xff, PMPUPR);
	writeb(0xff, PNPUPR);
	writew(0xffff, PPUPR1);
	writew(0xffff, PPUPR2);
	writew(0x2180, P1MSELR);
	writew(0x0000, P2MSELR);
/*
	write32	CCR_A,	CCR_D_C
	write32	CCR_A,	CCR_D_S
*/
	writel(0x00000808, CCR);
	writel(0x00000103, CCR);
		
	return 0;
}

int dram_init(void)
{
	DECLARE_GLOBAL_DATA_PTR;

	gd->bd->bi_memstart = CONFIG_SYS_SDRAM_BASE;
	gd->bd->bi_memsize = CONFIG_SYS_SDRAM_SIZE;
	printf("DRAM:  %dMB\n", CONFIG_SYS_SDRAM_SIZE / (1024 * 1024));
	return 0;
}

int board_eth_init(bd_t *bis)
{
	int rc = 0;
#ifdef CONFIG_SMC911X
	rc = smc911x_initialize(0, CONFIG_SMC911X_BASE);
#endif
	return rc;
}
