/*
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (C) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#include <config.h>
#include <version.h>
#include <asm/processor.h>
#include <asm/macro.h>

#include <asm/processor.h>

	.global	lowlevel_init

	.text
	.align	2

lowlevel_init:
	wait_timer	WAIT_200US
	wait_timer	WAIT_200US

	/*------- LBSC -------*/
	write32 MMSELR_A,	MMSELR_D

	/*------- DBSC2 -------*/
	write32 DBSC2_DBCONF_A,	DBSC2_DBCONF_D
	write32 DBSC2_DBTR0_A,	DBSC2_DBTR0_D
	write32 DBSC2_DBTR1_A,	DBSC2_DBTR1_D
	write32 DBSC2_DBTR2_A,	DBSC2_DBTR2_D
	write32 DBSC2_DBFREQ_A,	DBSC2_DBFREQ_D1
	write32 DBSC2_DBFREQ_A,	DBSC2_DBFREQ_D2
	wait_timer	WAIT_200US

	write32 DBSC2_DBDICODTOCD_A,	DBSC2_DBDICODTOCD_D
	write32 DBSC2_DBCMDCNT_A,	DBSC2_DBCMDCNT_D_CKE_H
	wait_timer	WAIT_200US
	write32 DBSC2_DBCMDCNT_A,	DBSC2_DBCMDCNT_D_PALL
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_EMRS2
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_EMRS3
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_EMRS1_1
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_MRS_1
	write32 DBSC2_DBCMDCNT_A,	DBSC2_DBCMDCNT_D_PALL
	write32 DBSC2_DBCMDCNT_A,	DBSC2_DBCMDCNT_D_REF
	write32 DBSC2_DBCMDCNT_A,	DBSC2_DBCMDCNT_D_REF
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_MRS_2
	wait_timer	WAIT_200US

	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_EMRS1_2
	write32 DBSC2_DBMRCNT_A,	DBSC2_DBMRCNT_D_EMRS1_1

	write32 DBSC2_DBEN_A,		DBSC2_DBEN_D
	write32 DBSC2_DBRFCNT1_A,	DBSC2_DBRFCNT1_D
	write32 DBSC2_DBRFCNT2_A,	DBSC2_DBRFCNT2_D
	write32 DBSC2_DBRFCNT0_A,	DBSC2_DBRFCNT0_D
	wait_timer	WAIT_200US

	/*------- GPIO -------*/
	write16 PACR_A,	PACR_D
	write16 PBCR_A,	PBCR_D
	write16 PCCR_A,	PCCR_D
	write16 PDCR_A,	PDCR_D
	write16 PECR_A,	PECR_D
	write16 PFCR_A,	PFCR_D
	write16 PGCR_A,	PGCR_D
	write16 PHCR_A,	PHCR_D
	write16 PJCR_A,	PJCR_D
	write16 PKCR_A,	PKCR_D
	write16 PLCR_A,	PLCR_D
	write16 PMCR_A,	PMCR_D
	write16 PNCR_A,	PNCR_D
	write16 PPCR_A,	PPCR_D
	write16 PQCR_A,	PQCR_D
	write16 PRCR_A,	PRCR_D

	write8	PEPUPR_A,	PEPUPR_D
	write8	PHPUPR_A,	PHPUPR_D
	write8	PJPUPR_A,	PJPUPR_D
	write8	PKPUPR_A,	PKPUPR_D
	write8	PLPUPR_A,	PLPUPR_D
	write8	PMPUPR_A,	PMPUPR_D
	write8	PNPUPR_A,	PNPUPR_D
	write16	PPUPR1_A,	PPUPR1_D
	write16	PPUPR2_A,	PPUPR2_D
	write16	P1MSELR_A,	P1MSELR_D
	write16	P2MSELR_A,	P2MSELR_D

	/*------- LBSC -------*/
	write32	BCR_A,		BCR_D
	write32	CS0BCR_A,	CS0BCR_D
	write32	CS0WCR_A,	CS0WCR_D
	write32	CS1BCR_A,	CS1BCR_D
	write32	CS1WCR_A,	CS1WCR_D
	write32	CS2BCR_A,	CS2BCR_D
	write32	CS2WCR_A,	CS2WCR_D
	write32	CS3BCR_A,	CS3BCR_D
	write32	CS3WCR_A,	CS3WCR_D
	write32	CS4BCR_A,	CS4BCR_D
	write32	CS4WCR_A,	CS4WCR_D
	write32	CS5BCR_A,	CS5BCR_D
	write32	CS5WCR_A,	CS5WCR_D
	write32	CS6BCR_A,	CS6BCR_D
	write32	CS6WCR_A,	CS6WCR_D

#if defined(CONFIG_SH_32BIT)
	/*------- set PMB -------*/
	write32	PASCR_A,	PASCR_29BIT_D
	write32	MMUCR_A,	MMUCR_D

	/*****************************************************************
	 * ent	virt		phys		v	sz	c	wt
	 * 0	0xa0000000	0x00000000	1	16M	0	0
	 * 1	0xa4000000	0x04000000	1	16M	0	0
	 * 9	0x8C000000	0x4C000000	1	64M	1	1
	 * 13	0xAC000000	0x4C000000	1	64M	0	0
	 */
	write32	PMB_ADDR_FLASH_A,	PMB_ADDR_FLASH_D
	write32	PMB_DATA_FLASH_A,	PMB_DATA_FLASH_D
	write32	PMB_ADDR_ETHER_A,	PMB_ADDR_ETHER_D
	write32	PMB_DATA_ETHER_A,	PMB_DATA_ETHER_D
	write32	PMB_ADDR_DDR_C_A,	PMB_ADDR_DDR_C_D
	write32	PMB_DATA_DDR_C_A,	PMB_DATA_DDR_C_D
	write32	PMB_ADDR_DDR_N_A,	PMB_ADDR_DDR_N_D
	write32	PMB_DATA_DDR_N_A,	PMB_DATA_DDR_N_D

	write32	PASCR_A,	PASCR_INIT
	mov.l	DUMMY_ADDR, r0
	icbi	@r0
#endif

	write32	CCR_A,	CCR_D_C
	write32	CCR_A,	CCR_D_S
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	rts
	nop

	.align 4

/*------- GPIO -------*/
PACR_D:		.long	0xFFFF
PBCR_D:		.long	0xFFF0
PCCR_D:		.long	0x0000
PDCR_D:		.long	0x0000
PECR_D:		.long	0x0FFF
PFCR_D:		.long	0x5555
PGCR_D:		.long	0x5555
PHCR_D:		.long	0x5410
PJCR_D:		.long	0x5551
PKCR_D:		.long	0x5555
PLCR_D:		.long	0x5551
PMCR_D:		.long	0xFFF5
PNCR_D:		.long	0x5555
PPCR_D:		.long	0x03C0
PQCR_D:		.long	0x03FF
PRCR_D:		.long	0x00FF

PEPUPR_D:	.long	0xFF
PHPUPR_D:	.long	0xFF
PJPUPR_D:	.long	0xFF
PKPUPR_D:	.long	0xFF
PLPUPR_D:	.long	0xFF
PMPUPR_D:	.long	0xFF
PNPUPR_D:	.long	0xFF
PPUPR1_D:	.long	0xFFFF
PPUPR2_D:	.long	0xFFFF
P1MSELR_D:	.long	0x2180
P2MSELR_D:	.long	0x0000

#define GPIO_BASE	0xFFE70000
PACR_A:		.long	GPIO_BASE + 0x00
PBCR_A:		.long	GPIO_BASE + 0x02
PCCR_A:		.long	GPIO_BASE + 0x04
PDCR_A:		.long	GPIO_BASE + 0x06
PECR_A:		.long	GPIO_BASE + 0x08
PFCR_A:		.long	GPIO_BASE + 0x0a
PGCR_A:		.long	GPIO_BASE + 0x0c
PHCR_A:		.long	GPIO_BASE + 0x0e
PJCR_A:		.long	GPIO_BASE + 0x10
PKCR_A:		.long	GPIO_BASE + 0x12
PLCR_A:		.long	GPIO_BASE + 0x14
PMCR_A:		.long	GPIO_BASE + 0x16
PNCR_A:		.long	GPIO_BASE + 0x18
PPCR_A:		.long	GPIO_BASE + 0x1a
PQCR_A:		.long	GPIO_BASE + 0x1c
PRCR_A:		.long	GPIO_BASE + 0x1e
PEPUPR_A:	.long	GPIO_BASE + 0x48
PHPUPR_A:	.long	GPIO_BASE + 0x4e
PJPUPR_A:	.long	GPIO_BASE + 0x50
PKPUPR_A:	.long	GPIO_BASE + 0x52
PLPUPR_A:	.long	GPIO_BASE + 0x54
PMPUPR_A:	.long	GPIO_BASE + 0x56
PNPUPR_A:	.long	GPIO_BASE + 0x58
PPUPR1_A:	.long	GPIO_BASE + 0x60
PPUPR2_A:	.long	GPIO_BASE + 0x62
P1MSELR_A:	.long	GPIO_BASE + 0x80
P2MSELR_A:	.long	GPIO_BASE + 0x82

MMSELR_A:      .long   0xFC400020
#if defined(CONFIG_SH_32BIT)
MMSELR_D:      .long   0xA5A50005
#else
MMSELR_D:      .long   0xA5A50001
#endif

/*------- DBSC2 -------*/
#define DBSC2_BASE	0xFE800000
DBSC2_DBSTATE_A:	.long	DBSC2_BASE + 0x0c
DBSC2_DBEN_A:		.long	DBSC2_BASE + 0x10
DBSC2_DBCMDCNT_A:	.long	DBSC2_BASE + 0x14
DBSC2_DBCONF_A:		.long	DBSC2_BASE + 0x20
DBSC2_DBTR0_A:		.long	DBSC2_BASE + 0x30
DBSC2_DBTR1_A:		.long	DBSC2_BASE + 0x34
DBSC2_DBTR2_A:		.long	DBSC2_BASE + 0x38
DBSC2_DBRFCNT0_A:	.long	DBSC2_BASE + 0x40
DBSC2_DBRFCNT1_A:	.long	DBSC2_BASE + 0x44
DBSC2_DBRFCNT2_A:	.long	DBSC2_BASE + 0x48
DBSC2_DBRFSTS_A:	.long	DBSC2_BASE + 0x4c
DBSC2_DBFREQ_A:		.long	DBSC2_BASE + 0x50
DBSC2_DBDICODTOCD_A:	.long	DBSC2_BASE + 0x54
DBSC2_DBMRCNT_A:	.long	DBSC2_BASE + 0x60

DBSC2_DBCONF_D:		.long	0x009A0002
DBSC2_DBTR0_D:		.long	0x050D1604
DBSC2_DBTR1_D:		.long	0x00040204
DBSC2_DBTR2_D:		.long	0x02120708
DBSC2_DBFREQ_D1:	.long	0x00000000
DBSC2_DBFREQ_D2:	.long	0x00000100
DBSC2_DBDICODTOCD_D:	.long	0x00000E07

DBSC2_DBCMDCNT_D_CKE_H:	.long	0x00000003
DBSC2_DBCMDCNT_D_PALL:	.long	0x00000002
DBSC2_DBCMDCNT_D_REF:	.long	0x00000004

DBSC2_DBMRCNT_D_EMRS2:		.long	0x00020000
DBSC2_DBMRCNT_D_EMRS3:		.long	0x00030000
DBSC2_DBMRCNT_D_EMRS1_1:	.long	0x00010040
DBSC2_DBMRCNT_D_EMRS1_2:	.long	0x000103C0
DBSC2_DBMRCNT_D_MRS_1:		.long	0x00000752
DBSC2_DBMRCNT_D_MRS_2:		.long	0x00000652

DBSC2_DBEN_D:		.long	0x00000001

DBSC2_DBRFCNT1_D:	.long	0x000007CF
DBSC2_DBRFCNT2_D:	.long	0x00C80080
DBSC2_DBRFCNT0_D:	.long	0x00010000

WAIT_200US:    .long   33333

/*------- LBSC -------*/
PASCR_A:		.long	0xFF000070

BCR_A:		.long	BCR
CS0BCR_A:	.long	CS0BCR
CS0WCR_A:	.long	CS0WCR
CS1BCR_A:	.long	CS1BCR
CS1WCR_A:	.long	CS1WCR
CS2BCR_A:	.long	CS2BCR
CS2WCR_A:	.long	CS2WCR
CS3BCR_A:	.long	CS3BCR
CS3WCR_A:	.long	CS3WCR
CS4BCR_A:	.long	CS4BCR
CS4WCR_A:	.long	CS4WCR
CS5BCR_A:	.long	CS5BCR
CS5WCR_A:	.long	CS5WCR
CS6BCR_A:	.long	CS6BCR
CS6WCR_A:	.long	CS6WCR

BCR_D:		.long	0x00000000
CS0BCR_D:	.long	0x11111632
CS0WCR_D:	.long	0x42000009
CS1BCR_D:	.long	0x11111A50
CS1WCR_D:	.long	0x02000004
CS2BCR_D:	.long	0x777777F0
CS2WCR_D:	.long	0x7777770F
CS3BCR_D:	.long	0x777777F0
CS3WCR_D:	.long	0x7777770F
CS4BCR_D:	.long	0x777777F0
CS4WCR_D:	.long	0x7777770F
CS5BCR_D:	.long	0x777777F0
CS5WCR_D:	.long	0x7777770F
CS6BCR_D:	.long	0x777777F0
CS6WCR_D:	.long	0x7777770F

#if defined(CONFIG_SH_32BIT)
/*------- set PMB -------*/
PMB_ADDR_FLASH_A:	.long	PMB_ADDR_BASE(0)
PMB_ADDR_ETHER_A:	.long	PMB_ADDR_BASE(1)
PMB_ADDR_DDR_C_A:	.long	PMB_ADDR_BASE(9)
PMB_ADDR_DDR_N_A:	.long	PMB_ADDR_BASE(13)

PMB_ADDR_FLASH_D:	.long	mk_pmb_addr_val(0xa0)
PMB_ADDR_ETHER_D:	.long	mk_pmb_addr_val(0xa4)
PMB_ADDR_DDR_C_D:	.long	mk_pmb_addr_val(0x8C)
PMB_ADDR_DDR_N_D:	.long	mk_pmb_addr_val(0xAC)

PMB_DATA_FLASH_A:	.long	PMB_DATA_BASE(0)
PMB_DATA_ETHER_A:	.long	PMB_DATA_BASE(1)
PMB_DATA_DDR_C_A:	.long	PMB_DATA_BASE(9)
PMB_DATA_DDR_N_A:	.long	PMB_DATA_BASE(13)

/*						ppn   ub v s1 s0  c  wt */
PMB_DATA_FLASH_D:	.long	mk_pmb_data_val(0x00, 1, 1, 0, 0, 0, 1)
PMB_DATA_ETHER_D:	.long	mk_pmb_data_val(0x04, 1, 1, 0, 0, 0, 1)
PMB_DATA_DDR_C_D:	.long	mk_pmb_data_val(0x4C, 0, 1, 0, 1, 1, 1)
PMB_DATA_DDR_N_D:	.long	mk_pmb_data_val(0x4C, 1, 1, 0, 1, 0, 1)

DUMMY_ADDR:	.long	0xA0000000
PASCR_29BIT_D:	.long	0x00000000
PASCR_INIT:	.long	0x80000080	/* check booting mode */
MMUCR_A:	.long	0xFF000010
MMUCR_D:	.long	0x00000004	/* clear ITLB */
#endif	/* CONFIG_SH_32BIT */

CCR_A:		.long	0xFF00001C
CCR_D_C:	.long	0x00000808
CCR_D_S:	.long	0x00000103
