/*
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (C) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/processor.h>

int checkboard(void)
{
	puts("BOARD: ALPHAPROJECT AP-SH4AD-0A\n");
	return 0;
}

int board_init(void)
{
	writew(0x4000, PACR);
	writew(0x1000, PBCR);
	writew(0x4000, PCCR);
	writew(0x1f55, PDCR);
	writew(0x0fff, PECR);
	writew(0x5555, PFCR);
	writew(0xd7ff, PGCR);
	writew(0x5410, PHCR);
	writew(0x5557, PJCR);
	/*
	  write16 PACR_A,	PACR_D
	  write16 PBCR_A,	PBCR_D
	  write16 PCCR_A,	PCCR_D
	  write16 PDCR_A,	PDCR_D
	  write16 PECR_A,	PECR_D
	  write16 PFCR_A,	PFCR_D
	  write16 PGCR_A,	PGCR_D
	  write16 PHCR_A,	PHCR_D
	  write16 PJCR_A,	PJCR_D

	  write8	PAPUPR_A,	PAPUPR_D
	  write8	PBPUPR_A,	PBPUPR_D
	  write8	PCPUPR_A,	PCPUPR_D
	  write8	PDPUPR_A,	PDPUPR_D
	  write8	PEPUPR_A,	PEPUPR_D
	  write8	PFPUPR_A,	PFPUPR_D
	  write8	PGPUPR_A,	PGPUPR_D
	  write8	PHPUPR_A,	PHPUPR_D
	  write8	PJPUPR_A,	PJPUPR_D
	  write16	PPUPR1_A,	PPUPR1_D
	  write16	PPUPR2_A,	PPUPR2_D
	  write16	P1MSELR_A,	P1MSELR_D
	  write16	P2MSELR_A,	P2MSELR_D
	*/

/*
PACR_D:		.long	0x4000
PBCR_D:		.long	0x1000
PCCR_D:		.long	0x4000
PDCR_D:		.long	0x1F55
PECR_D:		.long	0x0FFF
PFCR_D:		.long	0x5555
PGCR_D:		.long	0xD7FF
PHCR_D:		.long	0x5410
PJCR_D:		.long	0x5557
PAPUPR_D:	.long	0xFF
PBPUPR_D:	.long	0xFF
PCPUPR_D:	.long	0xFF
PDPUPR_D:	.long	0xFF
PEPUPR_D:	.long	0xFF
PFPUPR_D:	.long	0xFF
PGPUPR_D:	.long	0xFF
PHPUPR_D:	.long	0xFF
PJPUPR_D:	.long	0xFF
PPUPR1_D:	.long	0xFFFF
PPUPR2_D:	.long	0xFFFF
P1MSELR_D:	.long	0x0000
P2MSELR_D:	.long	0x0000

*/

	writel(0x00000808, CCR);
	writel(0x00000103, CCR);
/*	
CCR_D_C:	.long	0x00000808
CCR_D_S:	.long	0x00000103

	write32	CCR_A,	CCR_D_C
	write32	CCR_A,	CCR_D_S
*/

	return 0;
}

int dram_init(void)
{
	DECLARE_GLOBAL_DATA_PTR;

	gd->bd->bi_memstart = CONFIG_SYS_SDRAM_BASE;
	gd->bd->bi_memsize = CONFIG_SYS_SDRAM_SIZE;
	printf("DRAM:  %dMB\n", CONFIG_SYS_SDRAM_SIZE / (1024 * 1024));
	return 0;
}

int board_eth_init(bd_t *bis)
{
	int rc = 0;
#ifdef CONFIG_SMC911X
	rc = smc911x_initialize(0, CONFIG_SMC911X_BASE);
#endif
	return rc;
}
