/*
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (C) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#include <config.h>
#include <version.h>
#include <asm/processor.h>
#include <asm/macro.h>

#include <asm/processor.h>

	.global	lowlevel_init

	.text
	.align	2

lowlevel_init:
	/*------- LBSC -------*/
	write32 MMSELR_A,	MMSELR_D

	/*------- DBSC3 -------*/
	write32 DBSC3_DBRFEN_A,	DBSC3_DBRFEN_D_DISABLE
	write32 DBSC3_DBACEN_A,	DBSC3_DBACEN_D_DISABLE
	wait_timer	WAIT_100US
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_RSTL
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_PDEN
	write32 DBSC3_DBKIND_A,	DBSC3_DBKIND_D
	write32 DBSC3_DBCONF_A,	DBSC3_DBCONF_D

	write32 DBSC3_DBTR0_A,	DBSC3_DBTR0_D
	write32 DBSC3_DBTR1_A,	DBSC3_DBTR1_D
	write32 DBSC3_DBTR2_A,	DBSC3_DBTR2_D
	write32 DBSC3_DBTR3_A,	DBSC3_DBTR3_D
	write32 DBSC3_DBTR4_A,	DBSC3_DBTR4_D
	write32 DBSC3_DBTR5_A,	DBSC3_DBTR5_D
	write32 DBSC3_DBTR6_A,	DBSC3_DBTR6_D
	write32 DBSC3_DBTR7_A,	DBSC3_DBTR7_D
	write32 DBSC3_DBTR8_A,	DBSC3_DBTR8_D
	write32 DBSC3_DBTR9_A,	DBSC3_DBTR9_D
	write32 DBSC3_DBTR10_A,	DBSC3_DBTR10_D
	write32 DBSC3_DBTR11_A,	DBSC3_DBTR11_D
	write32 DBSC3_DBTR12_A,	DBSC3_DBTR12_D
	write32 DBSC3_DBTR13_A,	DBSC3_DBTR13_D
	write32 DBSC3_DBTR14_A,	DBSC3_DBTR14_D
	write32 DBSC3_DBTR15_A,	DBSC3_DBTR15_D
	write32 DBSC3_DBTR16_A,	DBSC3_DBTR16_D
	write32 DBSC3_DBTR17_A,	DBSC3_DBTR17_D

	write32 DBSC3_DBPDLCK_A,	DBSC3_DBPDLCK_D_UNLOCK
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_PACNT
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_PACNT
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_RSFTDQ0
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_RSFTDQ0
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_RSFTDQ1
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_RSFTDQ1
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_RSFTDQ2
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_RSFTDQ2
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_RSFTDQ3
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_RSFTDQ3
	write32 DBSC3_DBPDRGA_A,	DBSC3_DBPDRGA_D_RSFTFIN
	write32 DBSC3_DBPDRG_A,		DBSC3_DBPDRG_D_RSFTFIN
	write32 DBSC3_DBPDLCK_A,	DBSC3_DBPDLCK_D_LOCK

	write32 DBSC3_DBPDCNT3_A,	DBSC3_DBPDCNT3_D
	write32 DBSC3_DBPDCNT1_A,	DBSC3_DBPDCNT1_D
	wait_timer	WAIT_10US
	write32 DBSC3_DBPDCNT0_A,	DBSC3_DBPDCNT0_D
	wait_timer	WAIT_50US

	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_WAIT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_RSTH
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_WAIT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_WAIT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_WAIT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_WAIT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_PDXT
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_MRS2
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_MRS3
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_MRS1
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_MRS0
	write32 DBSC3_DBCMD_A,	DBSC3_DBCMD_D_ZQCL

	write32 DBSC3_DBBS0CNT0_A,	DBSC3_DBBS0CNT0_D
	write32 DBSC3_DBBS0CNT1_A,	DBSC3_DBBS0CNT1_D

	write32 DBSC3_DBRFCNF1_A,	DBSC3_DBRFCNF1_D
	write32 DBSC3_DBRFCNF2_A,	DBSC3_DBRFCNF2_D
	write32 DBSC3_DBRFCNF0_A,	DBSC3_DBRFCNF0_D

	write32 DBSC3_DBRFEN_A,	DBSC3_DBRFEN_D_ENABLE
	write32 DBSC3_DBACEN_A,	DBSC3_DBACEN_D_ENABLE

	wait_timer	WAIT_200US

	bra	gpio_init
	nop

	.align 4

/*---- Memory Map -----*/
MMSELR_A:      .long   0xFC400020
#if defined(CONFIG_SH_32BIT)
MMSELR_D:      .long   0xA5A50004
#else
MMSELR_D:      .long   0xA5A50003
#endif

/*------- DBSC3 -------*/
#define DBSC3_BASE	0xFFA00000
DBSC3_DBSTATE_A:	.long	DBSC3_BASE + 0x0C
DBSC3_DBACEN_A:		.long	DBSC3_BASE + 0x10
DBSC3_DBRFEN_A:		.long	DBSC3_BASE + 0x14
DBSC3_DBCMD_A:		.long	DBSC3_BASE + 0x18
DBSC3_DBWAIT_A:		.long	DBSC3_BASE + 0x1C
DBSC3_DBKIND_A:		.long	DBSC3_BASE + 0x20
DBSC3_DBCONF_A:		.long	DBSC3_BASE + 0x24
DBSC3_DBTR0_A:		.long	DBSC3_BASE + 0x40
DBSC3_DBTR1_A:		.long	DBSC3_BASE + 0x44
DBSC3_DBTR2_A:		.long	DBSC3_BASE + 0x48
DBSC3_DBTR3_A:		.long	DBSC3_BASE + 0x50
DBSC3_DBTR4_A:		.long	DBSC3_BASE + 0x54
DBSC3_DBTR5_A:		.long	DBSC3_BASE + 0x58
DBSC3_DBTR6_A:		.long	DBSC3_BASE + 0x5C
DBSC3_DBTR7_A:		.long	DBSC3_BASE + 0x60
DBSC3_DBTR8_A:		.long	DBSC3_BASE + 0x64
DBSC3_DBTR9_A:		.long	DBSC3_BASE + 0x68
DBSC3_DBTR10_A:		.long	DBSC3_BASE + 0x6C
DBSC3_DBTR11_A:		.long	DBSC3_BASE + 0x70
DBSC3_DBTR12_A:		.long	DBSC3_BASE + 0x74
DBSC3_DBTR13_A:		.long	DBSC3_BASE + 0x78
DBSC3_DBTR14_A:		.long	DBSC3_BASE + 0x7C
DBSC3_DBTR15_A:		.long	DBSC3_BASE + 0x80
DBSC3_DBTR16_A:		.long	DBSC3_BASE + 0x84
DBSC3_DBTR17_A:		.long	DBSC3_BASE + 0x88
DBSC3_DBRFCNF0_A:	.long	DBSC3_BASE + 0xE0
DBSC3_DBRFCNF1_A:	.long	DBSC3_BASE + 0xE4
DBSC3_DBRFCNF2_A:	.long	DBSC3_BASE + 0xE8
DBSC3_DBPDCNT0_A:	.long	DBSC3_BASE + 0x200
DBSC3_DBPDCNT1_A:	.long	DBSC3_BASE + 0x204
DBSC3_DBPDCNT2_A:	.long	DBSC3_BASE + 0x208
DBSC3_DBPDCNT3_A:	.long	DBSC3_BASE + 0x20C
DBSC3_DBPDLCK_A:	.long	DBSC3_BASE + 0x280
DBSC3_DBPDRGA_A:	.long	DBSC3_BASE + 0x290
DBSC3_DBPDRG_A:		.long	DBSC3_BASE + 0x2A0
DBSC3_DBBS0CNT0_A:	.long	DBSC3_BASE + 0x300
DBSC3_DBBS0CNT1_A:	.long	DBSC3_BASE + 0x304

WAIT_10US:	.long   1500	/*  10us / (1/533M x 4) */
WAIT_50US:	.long   7000	/*  50us / (1/533M x 4) */
WAIT_100US:	.long   15000	/* 100us / (1/533M x 4) */
WAIT_200US:	.long   30000	/* 200us / (1/533M x 4) */

DBSC3_DBKIND_D:		.long	0x00000007;
DBSC3_DBCONF_D:		.long	0x0D030A02
DBSC3_DBTR0_D:		.long	0x00000007
DBSC3_DBTR1_D:		.long	0x00000006
DBSC3_DBTR2_D:		.long	0x00000000
DBSC3_DBTR3_D:		.long	0x00000007
DBSC3_DBTR4_D:		.long	0x00070007
DBSC3_DBTR5_D:		.long	0x0000001B
DBSC3_DBTR6_D:		.long	0x00000014
DBSC3_DBTR7_D:		.long	0x00000006
DBSC3_DBTR8_D:		.long	0x0000001B
DBSC3_DBTR9_D:		.long	0x00000004
DBSC3_DBTR10_D:		.long	0x00000008
DBSC3_DBTR11_D:		.long	0x00000007
DBSC3_DBTR12_D:		.long	0x0000000F
DBSC3_DBTR13_D:		.long	0x0000003B
DBSC3_DBTR14_D:		.long	0x00000006
DBSC3_DBTR15_D:		.long	0x00000003
DBSC3_DBTR16_D:		.long	0x00160002
DBSC3_DBTR17_D:		.long	0x000C000C

DBSC3_DBCMD_D_RSTL:	.long	0x20000000
DBSC3_DBCMD_D_PDEN:	.long	0x1000D056

DBSC3_DBPDLCK_D_LOCK:		.long	0x00000000
DBSC3_DBPDLCK_D_UNLOCK:		.long	0x0000A55A
DBSC3_DBPDRGA_D_RSFTDQ0:	.long	0x00000018
DBSC3_DBPDRGA_D_RSFTDQ1:	.long	0x00000019
DBSC3_DBPDRGA_D_RSFTDQ2:	.long	0x0000001A
DBSC3_DBPDRGA_D_RSFTDQ3:	.long	0x0000001B
DBSC3_DBPDRGA_D_RSFTFIN:	.long	0x0000001C
DBSC3_DBPDRGA_D_PACNT:		.long	0x00000028
DBSC3_DBPDRG_D_RSFTDQ0:		.long	0x3220200F
DBSC3_DBPDRG_D_RSFTDQ1:		.long	0x3220200F
DBSC3_DBPDRG_D_RSFTDQ2:		.long	0x3220200F
DBSC3_DBPDRG_D_RSFTDQ3:		.long	0x3220200F
DBSC3_DBPDRG_D_RSFTFIN:		.long	0x00001313
DBSC3_DBPDRG_D_PACNT:		.long	0x00017200

DBSC3_DBPDCNT0_D:	.long	0x00000001
DBSC3_DBPDCNT1_D:	.long	0x00000001
DBSC3_DBPDCNT3_D:	.long	0x00004000

DBSC3_DBCMD_D_WAIT:	.long	0x0000D056
DBSC3_DBCMD_D_RSTH:	.long	0x2100D056
DBSC3_DBCMD_D_PDXT:	.long	0x11000041
DBSC3_DBCMD_D_MRS2:	.long	0x2A000008
DBSC3_DBCMD_D_MRS3:	.long	0x2B000000
DBSC3_DBCMD_D_MRS1:	.long	0x29000042
DBSC3_DBCMD_D_MRS0:	.long	0x28000930
DBSC3_DBCMD_D_ZQCL:	.long	0x03000200

DBSC3_DBBS0CNT0_D:	.long	0x00000000
DBSC3_DBBS0CNT1_D:	.long	0x00000000

DBSC3_DBRFCNF0_D:	.long	0x000000C8
DBSC3_DBRFCNF1_D:	.long	0x00000ED8
DBSC3_DBRFCNF2_D:	.long	0x00000000

DBSC3_DBACEN_D_ENABLE:	.long	0x00000001
DBSC3_DBACEN_D_DISABLE:	.long	0x00000000
DBSC3_DBRFEN_D_ENABLE:	.long	0x00000001
DBSC3_DBRFEN_D_DISABLE:	.long	0x00000000

	.align 4

gpio_init:
	/*------- GPIO -------*/
	write16 PACR_A,	PACR_D
	write16 PBCR_A,	PBCR_D
	write16 PCCR_A,	PCCR_D
	write16 PDCR_A,	PDCR_D
	write16 PECR_A,	PECR_D
	write16 PFCR_A,	PFCR_D
	write16 PGCR_A,	PGCR_D
	write16 PHCR_A,	PHCR_D
	write16 PJCR_A,	PJCR_D

	write8	PAPUPR_A,	PAPUPR_D
	write8	PBPUPR_A,	PBPUPR_D
	write8	PCPUPR_A,	PCPUPR_D
	write8	PDPUPR_A,	PDPUPR_D
	write8	PEPUPR_A,	PEPUPR_D
	write8	PFPUPR_A,	PFPUPR_D
	write8	PGPUPR_A,	PGPUPR_D
	write8	PHPUPR_A,	PHPUPR_D
	write8	PJPUPR_A,	PJPUPR_D
	write16	PPUPR1_A,	PPUPR1_D
	write16	PPUPR2_A,	PPUPR2_D
	write16	P1MSELR_A,	P1MSELR_D
	write16	P2MSELR_A,	P2MSELR_D

	bra	lbsc_init
	nop

	.align 4

/*------- GPIO -------*/
#define GPIO_BASE	0xFFCC0000
PACR_A:		.long	GPIO_BASE + 0x00
PBCR_A:		.long	GPIO_BASE + 0x02
PCCR_A:		.long	GPIO_BASE + 0x04
PDCR_A:		.long	GPIO_BASE + 0x06
PECR_A:		.long	GPIO_BASE + 0x08
PFCR_A:		.long	GPIO_BASE + 0x0a
PGCR_A:		.long	GPIO_BASE + 0x0c
PHCR_A:		.long	GPIO_BASE + 0x0e
PJCR_A:		.long	GPIO_BASE + 0x10
PAPUPR_A:	.long	GPIO_BASE + 0x40
PBPUPR_A:	.long	GPIO_BASE + 0x42
PCPUPR_A:	.long	GPIO_BASE + 0x44
PDPUPR_A:	.long	GPIO_BASE + 0x46
PEPUPR_A:	.long	GPIO_BASE + 0x48
PFPUPR_A:	.long	GPIO_BASE + 0x4A
PGPUPR_A:	.long	GPIO_BASE + 0x4C
PHPUPR_A:	.long	GPIO_BASE + 0x4E
PJPUPR_A:	.long	GPIO_BASE + 0x50
PPUPR1_A:	.long	GPIO_BASE + 0x60
PPUPR2_A:	.long	GPIO_BASE + 0x62
P1MSELR_A:	.long	GPIO_BASE + 0x80
P2MSELR_A:	.long	GPIO_BASE + 0x82

PACR_D:		.long	0x4000
PBCR_D:		.long	0x1000
PCCR_D:		.long	0x4000
PDCR_D:		.long	0x1F55
PECR_D:		.long	0x0FFF
PFCR_D:		.long	0x5555
PGCR_D:		.long	0xD7FF
PHCR_D:		.long	0x5410
PJCR_D:		.long	0x5557
PAPUPR_D:	.long	0xFF
PBPUPR_D:	.long	0xFF
PCPUPR_D:	.long	0xFF
PDPUPR_D:	.long	0xFF
PEPUPR_D:	.long	0xFF
PFPUPR_D:	.long	0xFF
PGPUPR_D:	.long	0xFF
PHPUPR_D:	.long	0xFF
PJPUPR_D:	.long	0xFF
PPUPR1_D:	.long	0xFFFF
PPUPR2_D:	.long	0xFFFF
P1MSELR_D:	.long	0x0000
P2MSELR_D:	.long	0x0000

lbsc_init:
	/*------- LBSC -------*/
	write32	BCR_A,		BCR_D
	write32	CS0BCR_A,	CS0BCR_D
	write32	CS0WCR_A,	CS0WCR_D
	write32	CS1BCR_A,	CS1BCR_D
	write32	CS1WCR_A,	CS1WCR_D
	write32	CS2BCR_A,	CS2BCR_D
	write32	CS2WCR_A,	CS2WCR_D
	write32	CS3BCR_A,	CS3BCR_D
	write32	CS3WCR_A,	CS3WCR_D
	write32	CS4BCR_A,	CS4BCR_D
	write32	CS4WCR_A,	CS4WCR_D
	write32	CS5BCR_A,	CS5BCR_D
	write32	CS5WCR_A,	CS5WCR_D
	write32	CS6BCR_A,	CS6BCR_D
	write32	CS6WCR_A,	CS6WCR_D

#if defined(CONFIG_SH_32BIT)
	/*------- set PMB -------*/
	write32	PASCR_A,	PASCR_29BIT_D
	write32	MMUCR_A,	MMUCR_D

	/*****************************************************************
	 * ent	virt		phys		v	sz	c	wt
	 * 0	0xa0000000	0x00000000	1	16M	0	0
	 * 1	0xa4000000	0x04000000	1	16M	0	0
	 * 9	0x88000000	0x48000000	1	64M	1	1
	 * 13	0xA8000000	0x48000000	1	64M	0	0
	 */
	write32	PMB_ADDR_FLASH_A,	PMB_ADDR_FLASH_D
	write32	PMB_DATA_FLASH_A,	PMB_DATA_FLASH_D
	write32	PMB_ADDR_ETHER_A,	PMB_ADDR_ETHER_D
	write32	PMB_DATA_ETHER_A,	PMB_DATA_ETHER_D
	write32	PMB_ADDR_DDR_C1_A,	PMB_ADDR_DDR_C1_D
	write32	PMB_DATA_DDR_C1_A,	PMB_DATA_DDR_C1_D
	write32	PMB_ADDR_DDR_C2_A,	PMB_ADDR_DDR_C2_D
	write32	PMB_DATA_DDR_C2_A,	PMB_DATA_DDR_C2_D
	write32	PMB_ADDR_DDR_N1_A,	PMB_ADDR_DDR_N1_D
	write32	PMB_DATA_DDR_N1_A,	PMB_DATA_DDR_N1_D
	write32	PMB_ADDR_DDR_N2_A,	PMB_ADDR_DDR_N2_D
	write32	PMB_DATA_DDR_N2_A,	PMB_DATA_DDR_N2_D

	write32	PASCR_A,	PASCR_INIT
	mov.l	DUMMY_ADDR,	r0
	icbi	@r0
#endif

	write32	CCR_A,	CCR_D_C
	write32	CCR_A,	CCR_D_S
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	rts
	nop

	.align 4

/*------- LBSC -------*/
PASCR_A:	.long	0xFF000070
BCR_A:		.long	BCR
CS0BCR_A:	.long	CS0BCR
CS0WCR_A:	.long	CS0WCR
CS1BCR_A:	.long	CS1BCR
CS1WCR_A:	.long	CS1WCR
CS2BCR_A:	.long	CS2BCR
CS2WCR_A:	.long	CS2WCR
CS3BCR_A:	.long	CS3BCR
CS3WCR_A:	.long	CS3WCR
CS4BCR_A:	.long	CS4BCR
CS4WCR_A:	.long	CS4WCR
CS5BCR_A:	.long	CS5BCR
CS5WCR_A:	.long	CS5WCR
CS6BCR_A:	.long	CS6BCR
CS6WCR_A:	.long	CS6WCR

BCR_D:		.long	0x00000000
CS0BCR_D:	.long	0x11111632
CS0WCR_D:	.long	0x42000008
CS1BCR_D:	.long	0x11111A40
CS1WCR_D:	.long	0x02000003
CS2BCR_D:	.long	0x777777F0
CS2WCR_D:	.long	0x7777770F
CS3BCR_D:	.long	0x777777F0
CS3WCR_D:	.long	0x7777770F
CS4BCR_D:	.long	0x777777F0
CS4WCR_D:	.long	0x7777770F
CS5BCR_D:	.long	0x777777F0
CS5WCR_D:	.long	0x7777770F
CS6BCR_D:	.long	0x777777F0
CS6WCR_D:	.long	0x7777770F

#if defined(CONFIG_SH_32BIT)
/*------- set PMB -------*/
PMB_ADDR_FLASH_A:	.long	PMB_ADDR_BASE(0)
PMB_ADDR_ETHER_A:	.long	PMB_ADDR_BASE(1)
PMB_ADDR_DDR_C1_A:	.long	PMB_ADDR_BASE(9)
PMB_ADDR_DDR_C2_A:	.long	PMB_ADDR_BASE(10)
PMB_ADDR_DDR_N1_A:	.long	PMB_ADDR_BASE(13)
PMB_ADDR_DDR_N2_A:	.long	PMB_ADDR_BASE(14)

PMB_ADDR_FLASH_D:	.long	mk_pmb_addr_val(0xa0)
PMB_ADDR_ETHER_D:	.long	mk_pmb_addr_val(0xa4)
PMB_ADDR_DDR_C1_D:	.long	mk_pmb_addr_val(0x88)
PMB_ADDR_DDR_C2_D:	.long	mk_pmb_addr_val(0x90)
PMB_ADDR_DDR_N1_D:	.long	mk_pmb_addr_val(0xA8)
PMB_ADDR_DDR_N2_D:	.long	mk_pmb_addr_val(0xb0)

PMB_DATA_FLASH_A:	.long	PMB_DATA_BASE(0)
PMB_DATA_ETHER_A:	.long	PMB_DATA_BASE(1)
PMB_DATA_DDR_C1_A:	.long	PMB_DATA_BASE(9)
PMB_DATA_DDR_C2_A:	.long	PMB_DATA_BASE(10)
PMB_DATA_DDR_N1_A:	.long	PMB_DATA_BASE(13)
PMB_DATA_DDR_N2_A:	.long	PMB_DATA_BASE(14)

/*						ppn   ub v s1 s0  c  wt */
PMB_DATA_FLASH_D:	.long	mk_pmb_data_val(0x00, 1, 1, 0, 0, 0, 1)
PMB_DATA_ETHER_D:	.long	mk_pmb_data_val(0x04, 1, 1, 0, 0, 0, 1)
PMB_DATA_DDR_C1_D:	.long	mk_pmb_data_val(0x48, 0, 1, 1, 0, 1, 1)
PMB_DATA_DDR_C2_D:	.long	mk_pmb_data_val(0x50, 0, 1, 1, 0, 1, 1)
PMB_DATA_DDR_N1_D:	.long	mk_pmb_data_val(0x48, 1, 1, 1, 0, 0, 1)
PMB_DATA_DDR_N2_D:	.long	mk_pmb_data_val(0x50, 1, 1, 1, 0, 0, 1)

DUMMY_ADDR:	.long	0xA0000000
PASCR_29BIT_D:	.long	0x00000000
PASCR_INIT:	.long	0x80000080	/* check booting mode */
MMUCR_A:	.long	0xFF000010
MMUCR_D:	.long	0x00000004	/* clear ITLB */
#endif	/* CONFIG_SH_32BIT */

CCR_A:		.long	0xFF00001C
CCR_D_C:	.long	0x00000808
CCR_D_S:	.long	0x00000103
