/*
 * Configuation settings for the ALPHAPROJECT AP-SH4A-2A board
 *
 * Copyright (C) 2010 ALPHAPROJECT Co.,Ltd. 
 * Copyright (C) 2008 Yoshihiro Shimoda <shimoda.yoshihiro@renesas.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __APSH4A3A_H
#define __APSH4A3A_H

#undef DEBUG
#define CONFIG_SH			1
#define CONFIG_SH4A			1
#define CONFIG_CPU_SH7785		1
#define CONFIG_APSH4A3A	1

#define CONFIG_CMD_BOOTD	/* bootd			*/
#define CONFIG_CMD_ELF
#define CONFIG_CMD_IMI
#define CONFIG_CMD_IMLS
#define CONFIG_CMD_FLASH
#define CONFIG_CMD_MEMORY
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_CMD_NFS
#define CONFIG_CMD_SDRAM
#define CONFIG_CMD_RUN
#define CONFIG_CMD_SAVEENV
#define CONFIG_CMD_JFFS2

#define CONFIG_BAUDRATE			115200
#define CONFIG_BOOTDELAY		3
#define CONFIG_BOOTARGS			"console=ttySC0," MK_STR(CONFIG_BAUDRATE)

#define	CONFIG_IPADDR			192.168.128.200
#define	CONFIG_SERVERIP			192.168.128.201
#define	CONFIG_NETMASK			255.255.255.0
#define CONFIG_GATEWAYIP		192.168.128.254

#define CONFIG_VERSION_VARIABLE
#undef	CONFIG_SHOW_BOOT_PROGRESS

/* MEMORY */
#if defined(CONFIG_SH_32BIT)
#define APSH4A3A_SDRAM_PHYS_BASE	(0x4C000000)
#define APSH4A3A_SDRAM_BASE		(0x8C000000)
#define APSH4A3A_SDRAM_SIZE		(64 * 1024 * 1024)
#define APSH4A3A_FLASH_BASE_1		(0xA0000000)
#define APSH4A3A_FLASH_BANK_SIZE	(16 * 1024 * 1024)
#else
#define APSH4A3A_SDRAM_BASE		(0x0C000000)
#define APSH4A3A_SDRAM_SIZE		(64 * 1024 * 1024)
#define APSH4A3A_FLASH_BASE_1		(0xA0000000)
#define APSH4A3A_FLASH_BANK_SIZE	(16 * 1024 * 1024)
#endif

#define CONFIG_SYS_LONGHELP
#define CONFIG_SYS_PROMPT		"=> "
#define CONFIG_SYS_CBSIZE		256
#define CONFIG_SYS_PBSIZE		256
#define CONFIG_SYS_MAXARGS		16
#define CONFIG_SYS_BARGSIZE		512
#define CONFIG_SYS_BAUDRATE_TABLE	{ 115200, 57600, 38400 }

/* SCIF */
#define CONFIG_SCIF_CONSOLE		1
#define CONFIG_CONS_SCIF0		1
#undef	CONFIG_SYS_CONSOLE_INFO_QUIET
#undef	CONFIG_SYS_CONSOLE_OVERWRITE_ROUTINE
#undef	CONFIG_SYS_CONSOLE_ENV_OVERWRITE


#define CONFIG_SYS_MEMTEST_START	(APSH4A3A_SDRAM_BASE)
#define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_MEMTEST_START + \
					(APSH4A3A_SDRAM_SIZE) - \
					 4 * 1024 * 1024)
#undef	CONFIG_SYS_ALT_MEMTEST
#undef	CONFIG_SYS_MEMTEST_SCRATCH
#undef	CONFIG_SYS_LOADS_BAUD_CHANGE

#define CONFIG_SYS_SDRAM_BASE		(APSH4A3A_SDRAM_BASE)
#define CONFIG_SYS_SDRAM_SIZE		(APSH4A3A_SDRAM_SIZE)
#define CONFIG_SYS_LOAD_ADDR		(CONFIG_SYS_SDRAM_BASE + 4 * 1024 * 1024)

#define CONFIG_SYS_MONITOR_BASE		(APSH4A3A_FLASH_BASE_1)
#define CONFIG_SYS_MONITOR_LEN		(512 * 1024)
#define CONFIG_SYS_MALLOC_LEN		(512 * 1024)
#define CONFIG_SYS_GBL_DATA_SIZE	(256)
#define CONFIG_SYS_BOOTMAPSZ		(8 * 1024 * 1024)

/* FLASH */
#define CONFIG_FLASH_CFI_DRIVER
#define CONFIG_SYS_FLASH_CFI
#undef	CONFIG_SYS_FLASH_QUIET_TEST
#define CONFIG_SYS_FLASH_EMPTY_INFO
#define CONFIG_SYS_FLASH_BASE		(APSH4A3A_FLASH_BASE_1)
#define CONFIG_SYS_MAX_FLASH_SECT	128

#define CONFIG_SYS_FLASH_CFI_WIDTH	(FLASH_CFI_16BIT)
#define CONFIG_SYS_MAX_FLASH_BANKS	1
#define CONFIG_SYS_FLASH_BANKS_LIST	{ CONFIG_SYS_FLASH_BASE + \
				 	(0 * APSH4A3A_FLASH_BANK_SIZE) }

#define CONFIG_SYS_FLASH_ERASE_TOUT	(3 * 1000)
#define CONFIG_SYS_FLASH_WRITE_TOUT	(3 * 1000)
#define CONFIG_SYS_FLASH_LOCK_TOUT	(3 * 1000)
#define CONFIG_SYS_FLASH_UNLOCK_TOUT	(3 * 1000)

#undef	CONFIG_SYS_FLASH_PROTECTION
#undef	CONFIG_SYS_DIRECT_FLASH_TFTP

/* SMC9118 */
#define CONFIG_NET_MULTI
#define CONFIG_SMC911X			1
#define CONFIG_SMC911X_16_BIT		1
#define CONFIG_SMC911X_BASE		0xA4000000

/* ENV setting */
#define CONFIG_ENV_IS_IN_FLASH
#define CONFIG_ENV_OVERWRITE		1
#define CONFIG_ENV_SECT_SIZE		(128 * 1024)
#define CONFIG_ENV_SIZE			(CONFIG_ENV_SECT_SIZE)
#define CONFIG_ENV_ADDR			(CONFIG_SYS_FLASH_BASE + CONFIG_SYS_MONITOR_LEN)
#define CONFIG_ENV_OFFSET		(CONFIG_ENV_ADDR - CONFIG_SYS_FLASH_BASE)
#define CONFIG_ENV_SIZE_REDUND		(CONFIG_ENV_SECT_SIZE)

/* Board Clock */
/* The SCIF used external clock. system clock only used timer. */
#define CONFIG_SYS_CLK_FREQ		49999500
#define CONFIG_SYS_TMU_CLK_DIV		4
#define CONFIG_SYS_HZ			1000

#endif	/* __APSH4A3A_H */
